function love.load()
	io.stdout:setvbuf('no')

	love.graphics.setDefaultFilter('linear', 'nearest')

	require 'colors'
	require 'images'
	require 'screenshake'
	require 'sun'
	require 'typer'
	require 'window'

	Typer:initialize()
	Sun:initialize()
	ScreenShake:initialize(1/100)
end

function love.update(dt)
	if not love.window.hasFocus() then return end

	Sun:update(dt)
	Typer:update(dt)
	ScreenShake.value = ScreenShake.value + Sun.speed*dt
end

function love.textinput(char)
	if Typer:textInput(char) then
		Sun:delay()
	end
end

function love.focus(f)
	if f then
		love.audio.setVolume(1)
	else
		love.audio.setVolume(0)
	end
end

function love.draw()
	love.graphics.setBackgroundColor(Sun:getSkyColor())

	Window:draw(function()
		ScreenShake:draw(function()
			Sun:draw()

			love.graphics.setColor(Colors.skyline)
			love.graphics.draw(Images.skyline,
				Window.gameWidth/2 - Images.skyline:getWidth()/2,
				Window.gameHeight - Images.skyline:getHeight() + 30)

			Typer:draw()
		end)

		Sun:drawLight()
	end)
end
