ScreenShake = {}

-- for precise randomness
local function random(min, max)
	return love.math.random() * (max - min) + min
end

function ScreenShake:initialize(intensity)
	self.value = 0
	self.intensity = intensity
	self.damping = 1
end

function ScreenShake:setShake(shake)
	self.value = shake
end

function ScreenShake:update(dt)
	self.value = self.value - self.damping*dt
	if self.value < 0 then
		self.value = 0
	end
end

function ScreenShake:draw(func)
	love.graphics.push()
		local shake = self.value * self.intensity
		love.graphics.translate(random(-shake, shake), random(-shake, shake))
		func()
	love.graphics.pop()
end
