Sun = {}

function Sun:initialize()
	self.position = 190
	self.speed = 1
	self.acceleration = 0.8
	self.light = 0
	self.rumble = love.audio.newSource('rumble.ogg', 'static') -- https://www.freesound.org/people/Reitanna/sounds/217657/

	self.rumble:setLooping(true)
	self.rumble:play()
end

function Sun:update(dt)
	self.speed = self.speed + self.acceleration*dt
	self.position = self.position - self.speed*dt

	if self.position < 50 then
		self.light = self.light + self.speed/10*dt
		if self.light > 1 then
			love.event.quit()
		end
	end

	self.rumble:setVolume(1 - (self.position / 190))
end

function Sun:delay()
	self.speed = 0
end

local function deltaRange(lower, upper, current)
	return 1 - (current - lower)/(upper - lower)
end

function Sun:getSkyColor()
	if self.position > 140 then
		return Colors.interpolate(Colors.sky1, Colors.sky2, deltaRange(140, 180, self.position))
	elseif self.position > 90 then
		return Colors.interpolate(Colors.sky2, Colors.sky3, deltaRange(90, 140, self.position))
	elseif self.position > 40 then
		return Colors.interpolate(Colors.sky3, Colors.sky4, deltaRange(40, 90, self.position))
	else
		return Colors.sky4
	end
end

function Sun:draw()
	love.graphics.setColor(Colors.sun)
	love.graphics.draw(Images.sun, Window.gameWidth/2 - Images.sun:getWidth()/2, -self.position)
end

function Sun:drawLight()
	if self.light > 0 then
		love.graphics.setColor(255, 255, 255, 255 * self.light)
		love.graphics.rectangle('fill', 0, 0, love.graphics.getDimensions())
	end
end
